Package org.apache.lucene.util

# Class BitSetIterator

java.lang.Object
org.apache.lucene.search.DocIdSetIterator
org.apache.lucene.util.BitSetIterator

public class BitSetIterator extends DocIdSetIterator
A `DocIdSetIterator` which iterates over set bits in a bit set.

NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

## Field Summary

### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

`NO_MORE_DOCS`

## Constructor Summary

Constructors
Constructor
Description
`BitSetIterator(BitSet bits, long cost)`
Sole constructor.

## Method Summary

Modifier and Type
Method
Description
`int`
`advance(int target)`
Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
`long`
`cost()`
Returns the estimated cost of this `DocIdSetIterator`.
`int`
`docID()`
Returns the following: `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
`BitSet`
`getBitSet()`
Return the wrapped `BitSet`.
`static FixedBitSet`
`getFixedBitSetOrNull(DocIdSetIterator iterator)`
If the provided iterator wraps a `FixedBitSet`, returns it, otherwise returns null.
`static SparseFixedBitSet`
`getSparseFixedBitSetOrNull(DocIdSetIterator iterator)`
If the provided iterator wraps a `SparseFixedBitSet`, returns it, otherwise returns null.
`int`
`nextDoc()`
Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
`void`
`setDocId(int docId)`
Set the current doc id that this iterator is on.

### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

`all, empty, range, slowAdvance`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### BitSetIterator

public BitSetIterator(BitSet bits, long cost)
Sole constructor.

## Method Details

### getFixedBitSetOrNull

public static FixedBitSet getFixedBitSetOrNull(DocIdSetIterator iterator)
If the provided iterator wraps a `FixedBitSet`, returns it, otherwise returns null.

### getSparseFixedBitSetOrNull

public static SparseFixedBitSet getSparseFixedBitSetOrNull(DocIdSetIterator iterator)
If the provided iterator wraps a `SparseFixedBitSet`, returns it, otherwise returns null.

### getBitSet

public BitSet getBitSet()
Return the wrapped `BitSet`.

### docID

public int docID()
Description copied from class: `DocIdSetIterator`
Returns the following:

- `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
- `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
- Otherwise it should return the doc ID it is currently on.

Specified by:
  `docID` in class `DocIdSetIterator`

### setDocId

public void setDocId(int docId)
Set the current doc id that this iterator is on.

### nextDoc

public int nextDoc()
Description copied from class: `DocIdSetIterator`
Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

Specified by:
  `nextDoc` in class `DocIdSetIterator`

### advance

public int advance(int target)
Description copied from class: `DocIdSetIterator`
Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

The behavior of this method is undefined when called with `target ≤ current` , or after the iterator has exhausted. Both cases may result in unpredicted behavior.

When `target > current` it behaves as if written:

     int advance(int target) {
       int doc;
       while ((doc = nextDoc()) < target) {
       }
       return doc;
     }

Some implementations are considerably more efficient than that.

NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

Specified by:
  `advance` in class `DocIdSetIterator`

### cost

public long cost()
Description copied from class: `DocIdSetIterator`
Returns the estimated cost of this `DocIdSetIterator`.

This is generally an upper bound of the number of documents this iterator might match, but may be a rough heuristic, hardcoded value, or otherwise completely inaccurate.

Specified by:
  `cost` in class `DocIdSetIterator`